#include<bits/stdc++.h>
using namespace std;
using ll = long long;

#define int ll
using pt = pair<int, int>;

#define x first
#define y second

pt operator-(pt a, pt b) {
    return {a.x - b.x, a.y - b.y};
}
int hp(pt p) {
    if (p.y > 0 || (p.y == 0 && p.x > 0)) return 1;
    return -1;
}
int vect(pt u, pt v) {
    return u.x * v.y - v.x * u.y;
}
struct DSU {
    vector<int> p, sz;
    DSU(int n) : p(n), sz(n, 1) {iota(p.begin(), p.end(),0);}
    int get(int x) {return p[x] != x ? p[x] = get(p[x]) : x;}
    void unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        p[u] = v;
        sz[v] += sz[u];
    }
};

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (auto &[x, y] : p) cin >> x >> y;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    int ans = n - 1;
    for (int x = 0; x < n; ++x) {
        int deg = g[x].size();
        vector<pair<int, int>> pts;
        for (int y : g[x]) {
            pts.push_back(p[y] - p[x]);
        }
        sort(pts.begin(), pts.end(), [&](auto p, auto q){if (hp(p) != hp(q)) return hp(p) < hp(q); return vect(p, q) > 0;});
        for (int i = 0; i < 2 * deg; ++i) pts.push_back(pts[i]);
        int j = 0;
        set<pair<int,int>> ok;
        DSU dsu(deg);
        for (int i = 0; i < deg; ++i) {
            j = max(j, i);
            while (j + 1 < i + deg && vect(pts[i], pts[j + 1]) >= 0) j++;
            if (i < j && vect(pts[i], pts[j]) == 0) ok.insert({i, j % deg});else {
                if (i < j) ok.insert({i, j % deg});
                if ((j + 1) % deg != i) ok.insert({i, (j + 1) % deg});
            }
        }
        for (auto [u, v] : ok) {
            assert(0 <= u && u < deg && 0 <= v && v < deg && u != v);
            if (ok.count({v, u})) dsu.unite(u, v);
        }
        for (int i = 0; i < deg; ++i) {
            if (dsu.get(i) == i) ans -= dsu.sz[i] / 2;
        }
    }
    cout << ans << '\n';
}
