﻿
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <queue>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

vector<vector<int>> g;
vector<bool> isLeaf;

int ans = 0;

void rec(int v, int lvl) {
    ans = max(ans, lvl);

    queue<int> bfs;
    bfs.push(v);
    bool hasLeaf = 0;
    while (!hasLeaf) {
        int sz = bfs.size();
        while (sz--) {
            int u = bfs.front();
            bfs.pop();
            for (int w : g[u]) {
                bfs.push(w);
                if (isLeaf[w])
                    hasLeaf = 1;
            }
        }
    }

    while (!bfs.empty()) {
        int u = bfs.front();
        bfs.pop();
        if (!isLeaf[u])
            rec(u, lvl + 1);
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int n; cin >> n;
    g.resize(n);
    isLeaf.resize(n, 0);
    for (int i = 1; i < n; i++) {
        int p; cin >> p;
        p--;
        g[p].push_back(i);
    }

    for (int i = 0; i < n; i++)
        if (g[i].empty())
            isLeaf[i] = 1;

    rec(0, 1);

    cout << ans;
}