﻿#pragma optimize("O2");

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

const int MOD = 1e9 + 7;

vector<ll> facts;
vector<ll> invs;

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int binpow(int bs, int ex) {
    if (ex == 0) return 1;

    if (ex & 1) return mul(bs, binpow(bs, ex - 1));

    int hf = binpow(bs, ex / 2);
    return mul(hf, hf);
}

int fact(int a) {
    if (a == 0) return 1;
    return mul(fact(a - 1), a);
}

int inv(int x) {
    return binpow(x, MOD - 2);
}

int nCk(int n, int k) {
    if (k > n) return 0;

    return mul(fact(n), mul(inv(fact(k)), inv(fact(n - k))));
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    ll n; cin >> n;
    facts.resize(n + 10, 1);
    invs.resize(n + 10, 1);
    for (int i = 1; i < n + 10; i++) {
        facts[i] = facts[i - 1] * i;
        facts[i] %= MOD;
        invs[i] = inv(facts[i]);
    }
    ll last = 1;
    for (int i = 2; i <= n; i++) {
        ll cnt = i;
        ll res = 0;
        ll groups = (ll)i - 1;
        ll twos = i / 2;
        ll ones = i % 2;
        while (twos + ones <= groups) {
            res += mul(mul(mul(facts[groups], invs[twos]), invs[ones]), invs[groups - twos - ones]);
            res %= MOD;
            twos--;
            ones += 2;
        }
        last = mul(last, res);
    }
    cout << last << endl;

}
