#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>
#include <cassert>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

vector<vector<int>> g;

vector<int> dp, d, mind;
vector<map<int, int>> max_dp;

void merge(map<int, int>& x,map<int, int>& y) {
    if (x.size() < y.size()) {
        swap(x, y);
    }
    for (auto [k, v] : y) {
        x[k] = max(x[k], v);
    }
}

void dfs(int v, int p) {
    dp[v] = 1;
    mind[v] = 1e9;
    for (auto u : g[v]) {
        if (u == p) {
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u, v);
        merge(max_dp[v], max_dp[u]);
        mind[v] = min(mind[v], mind[u]);
    }
    if (mind[v] == 1e9) {
        mind[v] = d[v];
    } else {
        dp[v] = max_dp[v][mind[v]] + 1;
    }
    max_dp[v][d[v]] = dp[v];
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[i].push_back(p);
        g[p].push_back(i);
    }
    dp.assign(n, 0);
    d.assign(n, 0);
    mind.assign(n, 0);
    max_dp.resize(n);
    dfs(0, -1);
    cout << dp[0] - 1 << "\n";
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}