#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>
#include <cassert>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

struct Square {
    int x, y, d;

    int dim() {
        if (x % 2 == 0 && y % 2 == 0)
            return 0;
        if (x % 2 == 0 && y % 2)
            return 1;
        if (x % 2 && y % 2 == 0)
            return 2;
        return 3;
    }

    Square() = default;
    Square(int x, int y) {
        this->x = x;
        this->y = y;
        d = dim();
    }

    bool operator<(Square sq) const {
        if (x == sq.x)
            return y < sq.y;
        return x < sq.x;
    }
};

int X[8] = {-1, -1, -1, 0, 0, 1, 1, 1}, Y[8] = {-1, 0, 1, -1, 1, -1, 0, 1};

struct ms {


    set<Square> d[4], added[4], deleted[4];

    void add(Square sq) {
        d[sq.d].insert(sq);
        for (int dim = 0; dim < 4; ++dim) {
            if (dim == sq.d)
                continue;
            bool found = false;
            for (int k = 0; k < 8; ++k) {
                Square nsq = {sq.x + X[k], sq.y + Y[k]};
                if (d[dim].find(nsq) != d[dim].end() || added[dim].find(nsq) != added[dim].end()) {
                    found = true;
                    break;
                }
            }
            if (found) {
                added[dim].erase(sq);
                deleted[dim].insert(sq);
            } else {
                added[dim].insert(sq);
                deleted[dim].erase(sq);
            }
        }
        for (int k = 0; k < 8; ++k) {
            Square nsq = {sq.x + X[k], sq.y + Y[k]};
            if (added[sq.d].find(nsq) != added[sq.d].end()) {
                deleted[sq.d].insert(nsq);
                added[sq.d].erase(nsq);
            }
        }
    }

    void erase(Square sq) {
        d[sq.d].erase(sq);
        for (int dim = 0; dim < 4; ++dim) {
            if (dim == sq.d)
                continue;
            added[dim].erase(sq);
            deleted[dim].erase(sq);
            for (int k = 0; k < 8; ++k) {
                Square nsq = {sq.x + X[k], sq.y + Y[k]};
                if (deleted[dim].find(nsq) != deleted[dim].end()) {
                    add(nsq);
                }
            }
        }
        for (int k = 0; k < 8; ++k) {
            Square nsq = {sq.x + X[k], sq.y + Y[k]};
            if (deleted[sq.d].find(nsq) != deleted[sq.d].end()) {
                add(nsq);
            }
        }
    }

    void query(int x, int y) {
        Square sq(x, y);
        if (d[sq.d].find(sq) == d[sq.d].end()) {
            add(sq);
        } else {
            erase(sq);
        }
    }

    int get() {
        int ans = 0;
        for (int dim = 0; dim < 4; ++dim) {
            ans = max(ans, (int)(d[dim].size() + added[dim].size()));
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    ms m;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        m.query(x, y);
        cout << m.get() << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}