#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

typedef long long ll;

const long long INF = 1e18, MOD = 1e9 + 7;
#define all(x) x.begin(), x.end()

long long n;
vector<long long> g[200000], to_lf, dp;
map<long long, long long> mp[200000];

void dfs1(long long v)
{
	to_lf[v] = INF;
	for (auto& i : g[v])
	{
		dfs1(i);
		to_lf[v] = min(to_lf[v], to_lf[i] + 1);
	}
	if (to_lf[v] == INF)
	{
		to_lf[v] = 0;
	}
}

void merge_mp(long long v, long long i)
{
	if (mp[v].size() < mp[i].size())
	{
		swap(mp[v], mp[i]);
	}
	for (auto& j : mp[i])
	{
		mp[v][j.first] = max(mp[v][j.first], j.second);
	}
}

void dfs2(long long v, long long ch)
{
	mp[v][ch] = -1;
	for (auto& i : g[v])
	{
		dfs2(i, ch + 1);
		merge_mp(v, i);
	}

	dp[v] = mp[v][ch + to_lf[v]] + 1;
	mp[v][ch] = max(mp[v][ch], dp[v]);
}

void solve()
{
	cin >> n;
	for (long long i = 1; i < n; i++)
	{
		long long par;
		cin >> par;
		par--;
		g[par].push_back(i);
	}
	to_lf.resize(n);
	dfs1(0);
	dp.resize(n);
	dfs2(0, 0);
	cout << dp[0] << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
