#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;
const int INF = 1e9;

#define int long long

int bin_pow(int a, int n) {
    int ans = 1;
    while (n > 0) {
        if (n & 1) {
            ans = ans * a % MOD;
        }
        n /= 2;
        a = a * a % MOD;
    }
    return ans;
}

struct SegmentTree {
    vector <int> tree;
    int sz;

    SegmentTree(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz, 0);
    }

    void assign(int pos, int x) {
        pos += sz;
        tree[pos] = x;
        for (pos /= 2; pos > 0; pos /= 2) {
            tree[pos] = tree[2 * pos] + tree[2 * pos + 1];
        }
    }

    int get(int l, int r) {
        l += sz;
        r += sz;
        int ans = 0;
        while (l <= r) {
            if (l % 2 == 1) {
                ans += tree[l];
                l++;
            }
            if (r % 2 == 0) {
                ans += tree[r];
                r--;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;

    string s;
    cin >> s;

    set <int> bbabb, bbb;
    for (int i = 0; i + 4 < n; i++) {
        if (s.substr(i, 5) == "bbabb") {
            bbabb.insert(i);
        }
    }
    for (int i = 0; i + 2 < n; i++) {
        if (s.substr(i, 3) == "bbb") {
            bbb.insert(i);
        }
    }

    SegmentTree even(n), odd(n);
    for (int i = 0; i < n; i++) {
        if (s[i] == 'b') {
            if (i % 2 == 0) {
                even.assign(i, 1);
            } else {
                odd.assign(i, 1);
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int ind;
            cin >> ind;
            ind--;

            if (ind % 2 == 0) {
                if (s[ind] == 'b') {
                    even.assign(ind, 0);
                } else {
                    even.assign(ind, 1);
                }
            } else {
                if (s[ind] == 'b') {
                    odd.assign(ind, 0);
                } else {
                    odd.assign(ind, 1);
                }
            }

            for (int i = max(0ll, ind - 4); i + 4 <= min(n - 1, ind + 4); i++) {
                if (s.substr(i, 5) == "bbabb") {
                    bbabb.erase(i);
                }
            }
            for (int i = max(0ll, ind - 2); i + 2 <= min(n - 1, ind + 2); i++) {
                if (s.substr(i, 3) == "bbb") {
                    bbb.erase(i);
                }
            }
            s[ind] = (s[ind] == 'a' ? 'b' : 'a');
            for (int i = max(0ll, ind - 4); i + 4 <= min(n - 1, ind + 4); i++) {
                if (s.substr(i, 5) == "bbabb") {
                    bbabb.insert(i);
                }
            }
            for (int i = max(0ll, ind - 2); i + 2 <= min(n - 1, ind + 2); i++) {
                if (s.substr(i, 3) == "bbb") {
                    bbb.insert(i);
                }
            }
        } else {
            int l, r;
            cin >> l >> r;
            l--; r--;

            if (l == r) {
                if (s[l] == 'b') {
                    cout << "NO\n";
                } else {
                    cout << "YES\n";
                }
                continue;
            }
            if (s[l] == 'b' && s[l + 1] == 'b') {
                cout << "NO\n";
                continue;
            }
            if (s[r] == 'b' && s[r - 1] == 'b') {
                cout << "NO\n";
                continue;
            }
            if (r - l + 1 <= 5) {
                int cnt = 0;
                for (int i = l; i <= r; i++) {
                    if (s[i] == 'a') {
                        cnt++;
                    } else {
                        cnt--;
                    }
                }
                if (cnt >= 0) {
                    cout << "YES\n";
                } else {
                    cout << "NO\n";
                }
                continue;
            }

            int mx = (r - l + 1) / 2;
            {
                int lb = 0, rb = mx + 1;
                while (rb - lb > 1) {
                    int m = (lb + rb) / 2; // [l; l + 2 * m - 1]
                    if (l % 2 == 0) {
                        if (even.get(l, l + 2 * m - 1) == m && odd.get(l, l + 2 * m - 1) == 0) {
                            lb = m;
                        } else {
                            rb = m;
                        }
                    } else {
                        if (odd.get(l, l + 2 * m - 1) == m && even.get(l, l + 2 * m - 1) == 0) {
                            lb = m;
                        } else {
                            rb = m;
                        }
                    }
                }
                l += 2 * lb;
            }
            if (l > r) {
                cout << "YES\n";
                continue;
            }
            {
                mx = (r - l + 1) / 2;
                int lb = 0, rb = mx + 1;
                while (rb - lb > 1) {
                    int m = (lb + rb) / 2; // [r - m * 2 + 1; r]
                    if (r % 2 == 0) {
                        if (even.get(r - m * 2 + 1, r) == m && odd.get(r - m * 2 + 1, r) == 0) {
                            lb = m;
                        } else {
                            rb = m;
                        }
                    } else {
                        if (odd.get(r - m * 2 + 1, r) == m && even.get(r - m * 2 + 1, r) == 0) {
                            lb = m;
                        } else {
                            rb = m;
                        }
                    }
                }
                r -= 2 * lb;
            }

            if (l > r) {
                cout << "YES\n";
                continue;
            }

            auto it = bbabb.lower_bound(l);
            if (it != bbabb.end() && *it + 4 <= r) {
                cout << "NO\n";
                continue;
            }
            auto itb = bbb.lower_bound(l);
            if (itb != bbb.end() && *it + 2 <= r) {
                cout << "NO\n";
                continue;
            }

            if (l == r) {
                if (s[l] == 'b') {
                    cout << "NO\n";
                } else {
                    cout << "YES\n";
                }
                continue;
            }
            if (s[l] == 'b' && s[l + 1] == 'b') {
                cout << "NO\n";
                continue;
            }
            if (s[r] == 'b' && s[r - 1] == 'b') {
                cout << "NO\n";
                continue;
            }

            if (r - l + 1 <= 5) {
                int cnt = 0;
                for (int i = l; i <= r; i++) {
                    if (s[i] == 'a') {
                        cnt++;
                    } else {
                        cnt--;
                    }
                }
                if (cnt >= 0) {
                    cout << "YES\n";
                } else {
                    cout << "NO\n";
                }
                continue;
            }

            cout << "YES\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
