#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define fi first
#define se second
#define pb push_back

const ll MOD = 1'000'000'000 + 7;
const int MAXN = 1e5 + 1;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

struct node{
    int v, l, r, l_num, r_num, num, cnt_a = 0;
};
vector <node> t(MAXN * 4);
vector <int> vec;
int n;

void build(int v = 1, int l = 0, int r = n - 1) {
    t[v].l = l;
    t[v].r = r;
    if (l == r) {
        t[v].num = vec[l];
        t[v].l_num = vec[l];
        t[v].r_num = vec[l];
        t[v].cnt_a = (vec[l] == 0);
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    t[v].num = max(t[v * 2].num, max(t[v * 2 + 1].num, t[v * 2].r_num + t[v * 2 + 1].l_num));
    t[v].cnt_a = t[v * 2].cnt_a + t[v * 2 + 1].cnt_a;
    if (t[v * 2].l_num == t[v * 2].r - t[v * 2].l + 1) {
        t[v].l_num = t[v].num;
    }
    else{
        t[v].l_num = t[v * 2].l_num;
    }
    if (t[v * 2 + 1].r_num == t[v * 2 + 1].r - t[v * 2 + 1].l + 1) {
        t[v].r_num = t[v].num;
    }
    else{
        t[v].r_num = t[v * 2 + 1].r_num;
    }
    return;
}

vector <int> get_mx(int ql, int qr, int v = 1) {
    int tl = t[v].l;
    int tr = t[v].r;
    if (ql <= tl && tr <= qr) {
        return {t[v].l_num, t[v].r_num, t[v].num, t[v].cnt_a};
    }
    if (ql > tr || qr < tl) {
        return {0, 0, 0, 0};
    }
    vector <int> v1 = get_mx(ql, qr, v * 2);
    vector <int> v2 = get_mx(ql, qr, v * 2 + 1);
    int num1, num2, num3;
    num1 = max(v1[2], max(v2[2], v1[1] + v2[0]));
    if (v1[0] == t[v * 2].r - t[v * 2].l + 1) {
        num2 = num1;
    }
    else{
        num2 = v1[0];
    }
    if (v2[1] == t[v * 2 + 1].r - t[v * 2 + 1].l + 1) {
        num3 = num1;
    }
    else{
        num3 = v2[1];
    }
    return {num2, num3, num1, v1[3] + v2[3]};
}

void update(int pos, int val, int v = 1) {
    int tl = t[v].l;
    int tr = t[v].r;
    if (tl == tr && tl == pos) {
        t[v].num = val;
        t[v].l_num = val;
        t[v].r_num = val;
        t[v].cnt_a = (val == 0);
        return;
    }
    if (pos < tl || pos > tr) {
        return;
    }
    update(pos, val, v * 2);
    update(pos, val, v * 2 + 1);
    t[v].num = max(t[v * 2].num, max(t[v * 2 + 1].num, t[v * 2].r_num + t[v * 2 + 1].l_num));
    t[v].cnt_a = t[v * 2].cnt_a + t[v * 2 + 1].cnt_a;
    if (t[v * 2].l_num == t[v * 2].r - t[v * 2].l + 1) {
        t[v].l_num = t[v].num;
    }
    else{
        t[v].l_num = t[v * 2].l_num;
    }
    if (t[v * 2 + 1].r_num == t[v * 2 + 1].r - t[v * 2 + 1].l + 1) {
        t[v].r_num = t[v].num;
    }
    else{
        t[v].r_num = t[v * 2 + 1].r_num;
    }
    return;
}

void out(int v = 1) {
    if (t[v].l == t[v].r) {
        cout << t[v].l << ' ' << t[v].r << ' ' << t[v].num << ' ' << t[v].l_num << ' ' << t[v].r_num << endl;
        return;
    }
    cout << t[v].l << ' ' << t[v].r << ' ' << t[v].num << ' ' << t[v].l_num << ' ' << t[v].r_num << endl;
    out(v * 2);
    out(v * 2 + 1);
    return;
}

void solve()
{
    cin >> n;
    vec.resize(n);
    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        vec[i] = (c == 'b');
    }
    build();
    //out();
    //cout << get_mx(1, 3)[2] << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int type;
        cin >> type;
        if (type == 2) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            if (l == r && vec[l] == 0) {
                cout << "YES" << endl;
                continue;
            }
            else if(l == r && vec[l] == 1) {
                cout << "NO" << endl;
                continue;
            }
            vector <int> vc = get_mx(l, r);
            if ((vec[l] == 1 && vec[l + 1] == 1) || (vec[r] == 1 && vec[r - 1] == 1) || vc[2] >= 3 || 2 * vc[3] < r - l + 1){
                cout << "NO" << endl;
                continue;
            }
            cout << "YES" << endl;
        }
        else{
            int p;
            cin >> p;
            p--;
            if (vec[p] == 0) {
                update(p, 1);
                vec[p] = 1;
            }
            else{
                update(p, 0);
                vec[p] = 0;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
