#include <iostream>
#include <iomanip>
#include <string>
#include <vector>

using namespace std;

using ll = long long;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;

    ll good = (n*n+1)*n/2;

    vector<vector<ll>> mat(n, vector<ll>(n));
    for(ll i = 0; i < n; ++i)
    {
        for(ll j = 0; j < n; ++j)
        {
            cin >> mat[i][j];
        }
    }

    vector<ll> rows(n), cols(n);

    for(ll i = 0; i < n; ++i)
    {
        for(ll j = 0; j < n; ++j)
        {
            rows[i] += mat[i][j];
            cols[j] += mat[i][j];
        }
    }

    vector<ll> BadRows;
    vector<ll> BadCols;

    for(ll i = 0; i < n; i++)
    {
        if (rows[i] != good)
        {
            BadRows.push_back(i);
        }
    }

    for(ll i = 0; i < n; i++)
    {
        if (cols[i] != good)
        {
            BadCols.push_back(i);
        }
    }

    if (BadCols.empty())
    {
        ll x1 = BadRows[0];
        ll x2 = BadRows[1];

        for(ll j = 0; j < n; j++)
        {
            if (rows[x1] - mat[x1][j] + mat[x2][j] == good)
            {
                cout << x1 + 1 << ' ' << j + 1 << '\n' << x2 + 1 << ' ' << j + 1;
                return 0;
            }
        }
    }
    else if (BadRows.empty())
    {
        ll y1 = BadCols[0];
        ll y2 = BadCols[1];

        for(ll i = 0; i < n; i++)
        {
            if (cols[y1] - mat[i][y1] + mat[i][y2] == good)
            {
                cout << i + 1 << ' ' << y1 + 1 << '\n' << i + 1 << ' ' << y2 + 1;
                return 0;
            }
        }
    }
    else
    {
        ll x1 = BadRows[0];
        ll x2 = BadRows[1];
        ll y1 = BadCols[0];
        ll y2 = BadCols[1];
        if (rows[x1] - mat[x1][y1] + mat[x2][y2] == good && cols[y1] - mat[x1][y1] + mat[x2][y2] == good)
        {
            cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
            return 0;
        }
        else
        {
            cout << x1 + 1 << ' ' << y2 + 1 << '\n' << x2 + 1 << ' ' << y1 + 1;
        }
    }

    return 0;
}
