#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()

#define int long long

const int m = 1e9 + 7;

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n & 1) return (a * binpow(a, n - 1)) % m;
    else {
        int b = binpow(a, n / 2);
        return b * b % m;
    }
}

int fact(int n) {
    if (n == 0) return 1;
    int ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans = ans * i % m;
    }
    return ans;
}

int pow2(int a, int n) {
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        ans = ans * a % m;
    }
    return ans;
}

struct Node {
    int cp, cs, len;
    bool was;

    Node() {
        cp = cs = len = 0;
        was = false;
    }
};

Node get_node(char c) {
    Node m;
    m.was = false;
    m.cp = m.cs = (c == 'b');
    m.len = 1;
    return m;
}

Node combine(Node l, Node r) {
    Node m;
    m.cp = l.cp + (l.cp == l.len ? r.cp : 0);
    m.cs = r.cs + (r.cs == r.len ? l.cs : 0);
    m.len = r.len + l.len;
    m.was = l.was | r.was | (l.cs + r.cp >= 3);
    return m;
}

vector<Node> t;

void build(int u, int tl, int tr, string &s) {
    if (tl + 1 == tr) {
        t[u] = get_node(s[tl]);
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * u + 1, tl, tm, s);
    build(2 * u + 2, tm, tr, s);
    t[u] = combine(t[2 * u + 1], t[2 * u + 2]);
}

Node query(int u, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l)
        return Node();
    if (l <= tl && tr <= r)
        return t[u];
    int tm = (tl + tr) / 2;
    return combine(
            query(2 * u + 1, tl, tm, l, r),
            query(2 * u + 2, tm, tr, l, r)
    );
}

void update(int u, int tl, int tr, int pos) {
    if (tl + 1 == tr) {
        t[u].cs = t[u].cp = (int) (!t[u].cs);
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) update(2 * u + 1, tl, tm, pos);
    else update(2 * u + 2, tm, tr, pos);
    t[u] = combine(t[2 * u + 1], t[2 * u + 2]);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
//    cin >> n;
//    while (n != 0) {
//
//        int ind = 1;
//        int q;
//        string str;
//        while (ind < n) {
//            if (n - ind >= 2) {
//                cout << "? " << ind << ' ' << "ab" << endl;
//                cin >> q;
//                if (q == 2) {
//                    str += "ab";
//                    cout << "? " << ind + 1 << ' ' << "bc" << endl;
//                    cin >> q;
//                    if (q == 2) {
//                        str += "c";
//                    } else {
//                        cout << "? " << ind + 1 << ' ' << "bb" << endl;
//                        cin >> q;
//                        if (q == 2) {
//                            str += "b";
//                        } else {
//                            str += "a";
//                        }
//                    }
//                } else if (q == 1) {
//                    cout << "? " << ind + 1 << ' ' << "ba" << endl;
//                    cin >> q;
//                    if (q == 0) {
//                        cout << "? " << ind + 1 << ' ' << "ab" << endl;
//                        cin >> q;
//                        if (q == 0) {
//                            str += "acc";
//                        } else if (q == 1) {
//                            cout << "? " << ind + 1 << ' ' << "ac" << endl;
//                            cin >> q;
//                            if (q == 0) {
//                                str += "acb";
//                            } else if (q == 2) {
//                                str += "aac";
//                            }
//                        } else {
//                            str += "aab";
//                        }
//                    } else if (q == 1) {
//                        cout << "? " << ind + 1 << ' ' << "bc" << endl;
//                        cin >> q;
//                        if (q == 0) {
//                            cout << "? " << ind + 1 << ' ' << "ca" << endl;
//                            cin >> q;
//                            if (q == 1) str += "aaa";
//                            else if (q == 1)str += "aca";
//                        } else if (q == 2) {
//                            cout << "? " << ind << ' ' << "bb" << endl;
//                            cin >> q;
//                            if (q == 1) str += "cbc";
//                            else if (q == 2) str += "bbc";
//                        } else {
//                            cout << "? " << ind << ' ' << "cb" << endl;
//                            cin >> q;
//                            if (q == 1) str += "bbb";
//                            else if (q == 2) str += "cbb";
//                        }
//                    } else if (q == 2) {
//                        cout << "? " << ind << ' ' << "cb" << endl;
//                        cin >> q;
//                        if (q == 1) str += "bba";
//                        else if (q == 2) str += "cba";
//                    }
//                } else if (q == 0) {
//                    cout << "? " << ind << ' ' << "ba" << endl;
//                    cin >> q;
//                    if (q == 0) {
//                        cout << "? " << ind + 1 << ' ' << "ca" << endl;
//                        cin >> q;
//                        if (q == 1) {
//                            cout << "? " << ind + 1 << ' ' << "cb" << endl;
//                            cin >> q;
//                            if (q == 1) str += "ccc";
//                            else if (q == 2) str += "ccb";
//                        } else if (q == 2) str += "cca";
//                    } else if (q == 1) {
//                        cout << "? " << ind + 1 << ' ' << "ab" << endl;
//                        cin >> q;
//                        if (q == 0) {
//                            cout << "? " << ind + 1 << ' ' << "cc" << endl;
//                            cin >> q;
//                            if (q == 1) str += "bca";
//                            else if (q == 2) str += "bcc";
//                        } else if (q == 1) {
//                            cout << "? " << ind + 1 << ' ' << "ac" << endl;
//                            cin >> q;
//                            if (q == 1) str += "caa";
//                            else if (q == 2) str += "cac";
//                            else if (q == 0) str += "bcb";
//                        } else if (q == 2) str += "cab";
//                    } else if (q == 2) {
//                        cout << "? " << ind + 1 << ' ' << "ac" << endl;
//                        cin >> q;
//                        if (q == 1) {
//                            cout << "? " << ind + 1 << ' ' << "ab" << endl;
//                            cin >> q;
//                            if (q == 1) str += "baa";
//                            else if (q == 2) str += "bab";
//                        } else if (q == 2) str += "bac";
//                    }
//                }
//                ind += 3;
//                //cout << str << endl;
//            } else {
//                break;
//            }
//        }
//        if (n - ind == 1) {
//            cout << "? " << ind << ' ' << "ab" << endl;
//            cin >> q;
//            if (q == 2) str += "ab";
//            else if (q == 1) {
//                cout << "? " << ind << ' ' << "ac" << endl;
//                cin >> q;
//                if (q == 2)str += "ac";
//                else if (q == 1) str += "aa";
//                else {
//                    cout << "? " << ind << ' ' << "bb" << endl;
//                    cin >> q;
//                    if (q == 2) str += "bb";
//                    else str += "cb";
//                }
//            } else {
//                cout << "? " << ind << ' ' << "bc" << endl;
//                cin >> q;
//                if (q == 2) str += "bc";
//                else if (q == 1) {
//                    cout << "? " << ind << ' ' << "ba" << endl;
//                    cin >> q;
//                    if (q == 2) str += "ba";
//                    else if (q == 0) str += "cc";
//                } else str += "ca";
//            }
//        } else if (n - ind == 0) {
//            ind--;
//            cout << "? " << ind << ' ' << string(1, str.back()) + "a" << endl;
//            cin >> q;
//            if (q == 1) {
//                cout << "? " << ind << ' ' << string(1, str.back()) + "b" << endl;
//                cin >> q;
//                if (q == 1) str += "c";
//                else if (q == 2) str += "b";
//            } else if (q == 2) str += "a";
//        }
//        cout << "! " + str << endl;
//        cin >> n;
//    }

    cin >> n;
    vector<vector<vector<int>>> dp(n + 10, vector<vector<int>>(n + 10, vector<int>(2, 0)));
    vector<vector<int>> pref(n + 10, vector<int>(n + 10, 0));
    for (int i = 1; i <= n; ++i) {
        dp[1][i][0] = 1;
        pref[1][i] = pref[1][i - 1] + 1;
    }

    for (int i = 2; i <= n; ++i) {
        for (int j = 1; j < n; ++j) {
            dp[i][j][1] = dp[i - 1][j][0];
            dp[i][j][0] = pref[i - 1][j - 1];
            int now = dp[i][j][0] + dp[i][j][1];
            pref[i][j] = now + pref[i][j - 1];
            pref[i][j] %= m;
        }
    }
    int res = 1;
    for (int level = 2; level <= n; ++level) {
        res *= pref[level][level - 1];
        res %= m;
    }
    cout << res << endl;
    return 0;
}
