#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

const int mod = 1e9 + 7;

int add(int a, int b) {
	if (a + b >= mod)
		return a + b - mod;
	return a + b;
}

int sub(int a, int b) {
	if (a < b)
		return a - b + mod;
	return a - b;
}

int mul(int a, int b) {
	return (int)((1ll * a * b) % mod);
}

int binpow(int a, int pw) {
	int b = 1;
	while (pw) {
		if (pw & 1)
			b = mul(b, a);
		a = mul(a, a);
		pw >>= 1;
	}
	return b;
}

int inv(int a) {
	return binpow(a, mod - 2);
}

const int N = 5010;
int f[N], r[N];

inline void precalc() {
	f[0] = 1;
	for (int i = 1; i < N; i++)
		f[i] = mul(f[i - 1], i);
	r[N - 1] = inv(f[N - 1]);
	for (int i = N - 2; i > -1; i--)
		r[i] = mul(r[i + 1], i + 1);
}

int C(int n, int k) {
	return mul(f[n], mul(r[k], r[n - k]));
}

int main()
{
	precalc();
	ll n; cin >> n; n--;
	ll var = 1;
	for(ll i = 2; i <= n; i++) {
		ll lvar = 0;
		for (ll c0 = 0; c0 <= i; c0++) {
			ll c2 = c0 + 1;
			ll c1 = i - c0 - c2;
			if (c1 < 0) continue;

			ll llvar = 1;
			llvar *= C(i, c0);
			llvar %= mod;
			llvar *= C(i - c0, c2);
			llvar %= mod;
			lvar += llvar;
			lvar %= mod;
		}
		var *= lvar;
		var %= mod;
	}
	cout << var << endl;
}