#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>

#define mp make_pair

using namespace std;
typedef long long i64;
typedef long long ll;
#define int long long

const int MAXN = 5009;
const int MOD = 1e9 + 7, INF = 1e9;

const i64 S = 2e5 + 100, B = 20;
i64 lg[S];

class SparseTable
{
public:
	int n;
	vector<i64> sp[B];

	void Build(vector<i64>& a)
	{
		n = a.size();
		for (int i = 0; i < B; i++)
		{
			sp[i].resize(n);
			for (int j = 0; j < n; j++)
			{
				if (i == 0)
				{
					sp[i][j] = a[j];
					continue;
				}
				sp[i][j] = max(sp[i - 1][j], sp[i - 1][min(j + (1 << (i - 1)), n - 1)]);
			}
		}
	}

	i64 Rmq(int l, int r)
	{
		int sz = r - l + 1;
		int fg = lg[sz];
		i64 ans = max(sp[fg][l], sp[fg][r - (1 << fg) + 1]);
		return ans;
	}
};

vector <i64> p[S]; i64 dp[S], tin[S], tout[S], from[S], t = 0;
vector <i64> h[S]; i64 mx_hei = 0;
vector <SparseTable> f;


void dfs(i64 v, i64 pr, i64 hei) {
	tin[v] = ++t;
	h[hei].push_back(v);
	dp[v] = INF; mx_hei = max(mx_hei, hei);
	bool child = true;
	for (auto x : p[v]) {
		if (x != pr) {
			dfs(x, v, hei + 1);
			child = false;
			dp[v] = min(dp[v], dp[x] + 1);
		}
	}
	if (child == true) {
		dp[v] = 0;
	}
	tout[v] = t;
}

bool is_child(i64 v, i64 par) {
	return tin[par] <= tin[v] && tout[v] <= tout[par];
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	i64 a; cin >> a;

	for (i64 x = 0; x < B; ++x) {
		if ((1 << x) < S) lg[1 << x] = x;
	}

	for (i64 x = 1; x < S; ++x) {
		if (lg[x] == 0) lg[x] = lg[x - 1];
	}

	for (i64 x = 2; x <= a; ++x) {
		i64 b; cin >> b;
		p[x].push_back(b), p[b].push_back(x);
	}

	dfs(1, 1, 0);
	f.resize(mx_hei + 1);

	for (i64 x = mx_hei; x >= 0; --x) {
		vector <i64> t;
		for (auto y : h[x]) {
			if (dp[y] == 0) {
				t.push_back(0);
				continue;
			}
			i64 l = -1, r = h[x + dp[y]].size();
			while (r - l > 1) {
				i64 mid = (l + r) / 2;
				i64 ind = h[x + dp[y]][mid];
				if (tin[ind] < tin[y]) l = mid;
				else r = mid;
			}
			i64 left = r;
			l = 0, r = h[x + dp[y]].size();
			while (r - l > 1) {
				i64 mid = (l + r) / 2;
				i64 ind = h[x + dp[y]][mid];
				if (tout[ind] <= tout[y]) l = mid;
				else r = mid;
			}
			i64 right = l;
			dp[y] = f[x + dp[y]].Rmq(left, right) + 1;
			t.push_back(dp[y]);
		}
		f[x].Build(t);
	}

	cout << dp[1];
}