#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const int MOD = 1e9 + 7;

vector<ll> fact, rfact;

ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}

ll C(ll n, ll k)
{
	if (k == 0) return 1;
	return (((fact[n] * rfact[n - k]) % MOD) * rfact[k]) % MOD;
}
ll mlt(ll a, ll b) {
	return (a * b) % MOD;
}
void solve()
{
	int n; cin >> n;
	fact.resize(n + 1, 1);
	rfact.resize(n + 1, 1);
	for (ll i = 1; i <= n; i++) fact[i] = (fact[i - 1] * i) % MOD;
	for (ll i = 1; i <= n; i++) rfact[i] = binpow(fact[i], MOD - 2);

	vector<ll>cnt(3);
	for (int i = 0; i < n; ++i) {
		int x; cin >> x;
		cnt[x % 3]++;
	}
	//cout << cnt[0] << " " << cnt[1] << " " << cnt[2] << "\n";
	if (n == 1) {
		if (cnt[0] == 1) { cout << 0; }
		else cout << 1;
		return;
	}
	if (n == 2) {
		if (cnt[0] == 2) { cout << 0; }
		else if (cnt[0] == 1) {
			cout << 1;
		}
		else cout << 2;
		return;
	}
	if (abs(cnt[1] - cnt[2]) != 1 and abs(cnt[1] - cnt[2]) != 2) {
		cout << 0;
		return;
	}
	cout << mlt(mlt(fact[cnt[1]], fact[cnt[2]]), mlt(fact[cnt[0]], C(cnt[0] + cnt[1] + cnt[2] - 1, cnt[1] + cnt[2] - 1)));
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}