#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e13;
const ll MOD = 1e9 + 7;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}

void solve()
{
	vector<int>ans_str(2), ans_col(2);
	set<pair<int, int>>used;
	map<int, vector<int>>cnt_str, cnt_col;
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x, y; cin >> x >> y;
		int x2 = abs(x % 2), y2 = abs(y % 2);
		if (used.find({ x,y }) == used.end()) {
			if (cnt_str[y].empty()) {
				cnt_str[y].resize(2, 0);
			}
			ans_str[y2] -= max(cnt_str[y][0], cnt_str[y][1]);
			cnt_str[y][x2]++;
			ans_str[y2] += max(cnt_str[y][0], cnt_str[y][1]);


			if (cnt_col[x].empty()) {
				cnt_col[x].resize(2, 0);
			}
			ans_col[x2] -= max(cnt_col[x][0], cnt_col[x][1]);
			cnt_col[x][y2]++;
			ans_col[x2] += max(cnt_col[x][0], cnt_col[x][1]);
			used.insert({ x,y });
		}
		cout << max(max(ans_str[0], ans_str[1]), max(ans_col[0],ans_col[1])) << "\n";
	}

}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}