#include <iostream>
#include <vector>
#include <string>

using namespace std;


string str(const string &s) {
    return s;
}

string str(int x) {
    return to_string(x);
}

template <typename type>
string str(const vector <type> &v) {
    string s = "[";
    for (int i = 0; i < (int) v.size(); ++i) {
        s += str(v[i]);
        if (i + 1 != (int) v.size()) {
            s += ", ";
        }
    }
    s += "]";
    return s;
}

#define debug(x) cout << (#x) << "=" << str(x) << "\n"


const int p = 1000000007;

int main() {
    int n;
    cin >> n;

    vector <vector <vector <int>>> dp(1 + n, vector <vector <int>> (50, vector <int> (1 + n)));
    for (int i = 0; i < 50; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[0][i][j] = 1;
        }
    }
    for (int x = 1; x <= n; ++x) {
        for (int i = 1; i < 50; ++i) {
            for (int m = 1; m <= n; ++m) {
                dp[x][i][m] = dp[x][i][m - 1];
                if (m == i) continue;
                int y = x - m;
                while (y >= 0) {
                    dp[x][i][m] += dp[y][i][m - 1];
                    dp[x][i][m] %= p;
                    y -= m;
                }
            }
        }
    }

    int s = 0;
    for (int i = 1; i * (i - 1) <= n + n; ++i) {
        s += (long long) i * dp[n - i * (i - 1) / 2][i][n] % p;
        s %= p;
    }
    cout << s << '\n';
}
