#include<bits/stdc++.h>
using namespace std;

int mod = 1e9 + 7;

int add(int a, int b) {
    return a + b >= mod ? a +  b - mod : a + b;
}

int sub(int a, int b) {
    return a >= b ? a - b : a + mod - b;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

int binpow(int a, int n) {
    int res = 1;
    for (; n; n >>= 1) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
    }
    return res;
}

struct segtree {
    int n;
    vector<int> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<int>(2 * n, -1e9)) {}

    void update(int k, int x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = max(tr[k << 1], tr[k << 1 | 1]));
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res,tr[l++]);
            if (~r & 1) res = max(res,tr[r--]);
        }
        return res;
    }
};

struct vvc {
    map<int, array<int, 2>> mp;
    vector<int> cc;

    vvc() {
        cc.assign(2, 0);
    }

    void add(int x, int y) {
        cc[abs(x) % 2] -= max(mp[x][0], mp[x][1]);
        mp[x][abs(y) % 2]++;
        cc[abs(x) % 2] += max(mp[x][0], mp[x][1]);
    }

    void del(int x, int y) {
        cc[abs(x) % 2] -= max(mp[x][0], mp[x][1]);
        mp[x][abs(y) % 2]--;
        cc[abs(x) % 2] += max(mp[x][0], mp[x][1]);
    }

    int get() {
        return max(cc[0], cc[1]);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    vvc a, b;
    set<pair<int, int>> st;
    while (n--) {
        int x, y;
        cin >> x >> y;
        if (st.count({x, y})) {
            st.erase({x, y});
            a.del(x, y);
            b.del(y, x);
        } else {
            st.insert({x, y});
            a.add(x, y);
            b.add(y, x);
        }
        cout << max(a.get(), b.get()) << '\n';
    }
}