#include<bits/stdc++.h>
using namespace std;

using vec = pair<long long, long long>;

vec operator-(vec a, vec b) {
    return {a.first - b.first, a.second - b.second};
}

long long cross_prod(vec a, vec b) {
    return a.first * b.second - a.second * b.first;
}

long long dot_prod(vec a, vec b) {
    return a.first * b.first + a.second * b.second;
}

bool cmp(vec a, vec b){
    bool a0 = (a.first >= 0 && a.second > 0) || (a.first < 0 && a.second >= 0);
    bool b0 = (b.first >= 0 && b.second > 0) || (b.first < 0 && b.second >= 0);
    if(a0 && !b0)
        return true;
    if(!a0 && b0)
        return false;
    return cross_prod(a, b) > 0;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    vector<vec>xx(n);
    for (int i = 0; i < n; ++i) cin >> xx[i].first >> xx[i].second;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int ans = n - 1;
    auto dfs = [&](auto dfs, int u, int p) -> void {
        vector<vec> a;
        for (auto to : g[u]) {
            a.push_back(xx[to] - xx[u]);
            if (to != p) {
                dfs(dfs, to, u);
            }
        }
        sort(a.begin(), a.end(), cmp);
//        cout << u << endl;
//        for (auto [x, y] : a) cout << x << ' ' << y << endl;
        vector<set<int>> gr(a.size());
        for (int i = 0; i < a.size(); ++i) {
            auto v = a[i];
            v.first *= -1;
            v.second *= -1;
            int L = -1, R = a.size();
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (cmp(v, a[M]) || (cross_prod(v, a[M]) == 0 && dot_prod(v, a[M]) >= 0)) R = M;
                else L = M;
            }
//            cout << u << ' ' << i << ' ' << R << endl;
            if (R < a.size() && cross_prod(v, a[R]) == 0 && dot_prod(v, a[R]) >= 0) {
//                cout << u << ' ' << i << ' ' << R << endl;
                if (R != i) gr[i].insert(R);
            } else {
                for (auto x : {R % (int)a.size(), (R - 1 + (int)a.size()) % (int)a.size()}) {
                    if (i != x) gr[i].insert(x);
                }
            }
        }
        vector<vector<int>> grr(a.size());
        for (int i = 0; i < a.size(); ++i) {
            for (auto j : gr[i]) {
                if (gr[j].count(i)) grr[i].push_back(j);
            }
        }
//        cout << endl;
//        cout << u << ' ' << a.size() << endl;
//        for (int i = 0; i < a.size(); ++i) {
//            for (auto j : grr[i]) cout << j << ' ';
//            cout << endl;
//        }
//        cout << endl;
        int sz;
        vector<bool> used(a.size());
        auto go = [&](auto go, int u) -> void {
            used[u] = 1;
            sz++;
            for (auto to : grr[u]) {
                if (!used[to]) go(go, to);
            }
        };
        for (int i = 0; i < a.size(); ++i) {
            if (!used[i]) {
                sz = 0;
                go(go, i);
                ans -= sz / 2;
            }
        }
    };
    dfs(dfs, 0, -1);
    cout << ans;
}