#include <bits/stdc++.h>

struct Vector {
    int x, y;

    Vector() : x(0), y(y) { ; }
    Vector(int x, int y) : x(x), y(y) { ; }

    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }
    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }

    int64_t operator%(const Vector& other) const {
        return int64_t(x) * other.y - int64_t(y) * other.x;
    }
};

bool cmp_ang(Vector a, Vector b) {
    bool aa = a.y < 0 || a.y == 0 && a.x < 0;
    bool bb = b.y < 0 || b.y == 0 && b.x < 0;
    if (aa != bb) {
        return aa < bb;
    }
    return a % b > 0;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    // std::cerr << clock() * 1.0 / CLOCKS_PER_SEC << std::endl;

    // return 0;
    std::mt19937 rnd;

    int n;
    n = 1e5;
    std::cin >> n;
    std::vector<Vector> input(n);

    for (auto& [x, y] : input) {
        // x = rnd() % int(1e9);
        // y = rnd() % int(1e9);
        std::cin >> x >> y;
    }
    std::vector<std::vector<int>> gr(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        u = i;
        u = 1;
        v = i + 1;
        std::cin >> u >> v;

        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    int ans = 0;
    std::map<int64_t, int> map;
    for (int i = 0; i < n; i++) {
        map.clear();
        const int g = gr[i].size();
        std::vector<Vector> vec(g);
        std::vector<std::vector<int>> cum(g);
        // if (i % 1000 == 0)
        //     std::cerr << i << " ";

        // continue;
        for (int t = 0; t < g; t++) {
            vec[t] = input[gr[i][t]] - input[i];
        }

        std::sort(vec.begin(), vec.end(), cmp_ang);
        auto hash = [&](std::pair<int, int> p) {
            return int64_t(p.first) * (1 << 30) + p.second;
        };
        for (int i = 0; i < g; i++) {
            auto a = Vector() - vec[i];
            int it1 = std::lower_bound(vec.begin(), vec.end(), a, cmp_ang) - vec.begin();
            it1 %= g;
            int it2 = std::upper_bound(vec.begin(), vec.end(), a, cmp_ang) - vec.begin();
            it2 = (it2 + g - 1) % g;
            if (it1 == it2) {
                map[hash({std::min<int>(it1, i), std::max<int>(i, it1)})]++;
                continue;
            }
            map[hash({std::min<int>(it1, i), std::max<int>(i, it1)})]++;
            map[hash({std::min<int>(it2, i), std::max<int>(i, it2)})]++;
        }

        for (auto& [pp, c] : map) {
            std::pair<int, int> p(pp & 0xFFFFFF, pp >> 30);
            assert(c <= 2);
            if (c == 2) {
                cum[p.first].push_back(p.second);
                cum[p.second].push_back(p.first);
            }
        }

        std::vector<int> used(g);
        auto dfs = [&](auto dfs, int v) -> int {
            if (used[v]) {
                return 0;
            }
            used[v] = true;
            int res = 1;
            for (int t : cum[v]) {
                res += dfs(dfs, t);
            }
            return res;
        };
        int cnt = 0;
        for (int i = 0; i < g; i++) {
            cnt += dfs(dfs, i) / 2;
        }

        ans += g - 2 * cnt;
    }

    assert(ans % 2 == 0);
    ans /= 2;

    std::cout << ans << "\n";
    std::cerr << clock() * 1.0 / CLOCKS_PER_SEC << std::endl;

    return 0;
}
