#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const int MAXN = 2e5;

vector<int> g[MAXN];
int used[MAXN], h[MAXN], leaf[MAXN], ans[MAXN];

void dfs(int v, set<pair<int, int>> &root) {
    used[v] = ans[v] = 1;
    leaf[v] = MAXN;

    if ((int)g[v].size() == 1 && v) {
        leaf[v] = h[v];
    }

    for (auto to : g[v]) {
        if (!used[to]) {
            h[to] = h[v] + 1;

            ans[v] = max(ans[v], ans[to]);
            set<pair<int, int>> tmp;
            dfs(to, tmp);

            leaf[v] = min(leaf[v], leaf[to]);

            if ((int)root.size() > (int)tmp.size()) {
                for (auto kek : tmp) {
                    root.insert(kek);
                }
            } else {
                for (auto kek : root) {
                    tmp.insert(kek);
                }
                swap(root, tmp);
            }
        }
    }

//    cout << v + 1 << ' ' << leaf[v] + 1 << '\n';
//    for (auto kid : root) {
//        cout << kid.second << ' ';
//    }
//    cout << '\n';

    auto it = root.lower_bound({leaf[v] + 1, -1});
    if (it != root.end()) {
        it = root.lower_bound({leaf[v] + 2, -1});
        --it;
        ans[v] = it->second + 1;
    }
    root.insert({h[v], ans[v]});
}

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;

        g[i].push_back(p);
        g[p].push_back(i);
    }

    set<pair<int, int>> govno;
    dfs(0, govno);

//    for (int i = 0; i < n; ++i) {
//        cout << leaf[i] << ' ';
//    }
//    cout << '\n';
    cout << ans[0];
}