#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

int binexp(int base, int pwr) {
    if (pwr == 0) return 1;

    if (pwr % 2 == 0) {
        int x = binexp(base, pwr / 2);
        return (x * x) % MOD;
    } else {
        return (base * binexp(base, pwr - 1)) % MOD;
    }
}

vector<int> fac(5010, 1);
vector<int> inv_fac(5010, 1);

int Cnk(int n, int k) {
    return fac[n] * inv_fac[n - k] % MOD * inv_fac[k] % MOD;
}

signed main() {
    int n; cin >> n;
    for (int i = 2; i <= 5000; i++) {
        fac[i] = (fac[i - 1] * i) % MOD;
    }
    for (int i = 0; i <= 5000; i++) {
        inv_fac[i] = binexp(fac[i], MOD - 2);
    }
    int ans = 1;
    for (int i = 1; i < n; i++) {
        //from i to i + 1
        int a2 = 0;
        for (int a = 1; a <= (i + 1) / 2; a++) {
            int b = i - a;
            int buf = Cnk(i, a) * Cnk(i - a, b) % MOD;
//            cout << i << ' ' << buf << '\n';
            a2 = (a2 + buf) % MOD;
        }
        ans = ans * a2 % MOD;
    }
    cout << ans << '\n';
}