#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;
const int maxn = 1e5;

int binexp(int base, int pwr) {
    if (pwr == 0) return 1;

    if (pwr % 2 == 0) {
        int x = binexp(base, pwr / 2);
        return (x * x) % MOD;
    } else {
        return (base * binexp(base, pwr - 1)) % MOD;
    }
}

vector<int> fac(maxn + 1, 1);
vector<int> inv_fac(maxn + 1, 1);


signed main() {
    for (int i = 2; i <= maxn; i++)
        fac[i] = (fac[i - 1] * i) % MOD;
    for (int i = 0; i <= maxn; i++)
        inv_fac[i] = binexp(fac[i], MOD - 2);

    int n; cin >> n;
    vector<int> c(3, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        c[x % 3] += 1;
    }
    if (!(-1 <= c[1] - c[2] && c[1] - c[2] <= 2)) {
        cout << 0 << endl;
        exit(0);
    }
    int ans = fac[c[1]] * fac[c[2]] % MOD;
    ans = ans * fac[c[1] + c[2] + c[0] - 1] % MOD * inv_fac[c[1] + c[2] - 1] % MOD;
    if (c[1] == c[2])
        ans = ans * 2 % MOD;
    cout << ans << '\n';
}