#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()

using namespace std;

//#define int ll

string s;

struct node{

    vector<vector<int>> a;
    int l, r;

    node(){
        a.resize(2, vector<int>(2));
    }

    node(int l_, int r_, int x){
        a = {{0, 0}, {0, 0}};
        l = l_;
        r = r_;
    }

    node(int l, int r){
        this->l = l;
        this->r = r;
        a.resize(2, vector<int>(2));
    }

};

int f(int i){
    if(s[i] == 'a' && s[i - 1] == 'a'){
        return -1;
    }
    if(s[i] == 'b' && s[i - 1] == 'b'){
        return 1;
    }
    return 0;
}

int p(int i){
    return s[i] == 'b';
}

node merge(node a, node b){
    node ans;
    ans.l = a.l;
    ans.r = b.r;
    ans.a.resize(2, vector<int>(2));
    for(int i = 0; i < 2; ++i){
        if(a.a[i][0] == 1){
            ans.a[i][0] = 1;
            continue;
        }
        int nxt = max(0, a.a[i][1] + f(a.r));
        if(nxt > 1 || b.a[nxt][0] == 1){
            ans.a[i][0] = 1;
            continue;
        }
        ans.a[i][0] = 0;
        ans.a[i][1] = b.a[nxt][1];
    }
    return ans;
}

struct tree{

    int n;
    vector<node> t;

    void build(int v, int l, int r){
        if(l + 1 == r){
            t[v].l = l;
            t[v].r = r;
            t[v].a[0] = {0, p(l)};
            t[v].a[1] = {p(l), p(l)};
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

    tree(int n_){
        n = n_;
        t.resize(4 * n);
        build(0, 0, n);
    }

    node get(int v, int vl, int vr, int ql, int qr){
        if(vr <= ql || qr <= vl){
            return node(vl, vr, 1);
        }
        if(ql <= vl && vr <= qr){
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return merge(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
    }

    void change(int v, int l, int r, int ind){
        if(l > ind || r <= ind) return;
        if(l + 1 == r) {
            if(s[ind] == 'a'){
                s[ind] = 'b';
            }
            else{
                s[ind] = 'a';
            }
            t[v].l = l;
            t[v].r = r;
            t[v].a[0] = {0, p(l)};
            t[v].a[1] = {p(l), 1};
            return;
        }
        int mid = (l + r) / 2;
        change(2 * v + 1, l, mid, ind);
        change(2 * v + 2, mid, r, ind);
        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
    }

};

void solve(){
    int n;
    cin >> n;
    string cur;
    cin >> cur;
    s.push_back(cur[0]);
    s += cur;
    s.push_back(cur[len(cur) - 1]);
    tree t(n + 2);
    int q;
    cin >> q;
    while(q--){
        int typ;
        cin >> typ;
        if(typ == 1){
            int x;
            cin >> x;
            --x;
            if(x == 0){
                t.change(0, 0, n + 2, x);
                t.change(0, 0, n + 2, x + 1);
            }
            else if(x == n - 1){
                t.change(0, 0, n + 2, x + 1);
                t.change(0, 0, n + 2, x + 2);
            }
            else{
                t.change(0, 0, n + 2, x + 1);
            }
        }
        else{
            int l, r;
            cin >> l >> r;
            --l;
            if(r == n) r += 2;
            else ++r;
            node ans = t.get(0, 0, n + 2, l, r);
            if(ans.a[p(s[l])][0] == 1){
                cout << "NO\n";
            }
            else{
                cout << "YES\n";
            }
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}