#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr ll infLL = 3e18;

struct Info {
    array<array<ll, 2>, 2> dp{};
    int len = 0;
    int lIdx = -1, rIdx = -1;
    void nul() {
        dp[0][0] = dp[0][1] = dp[1][0] = dp[1][1] = -infLL;
        lIdx = rIdx = -1;
        len = 0;
    }
    Info() {
        nul();
    }
};

constexpr int N = 1 << 18;
ll W[N], D[N];

int sz = 1;


Info operator+(const Info &a, const Info &b) {
    if (a.len == 0 || b.len == 0) {
        return a.len == 0 ? b : a;
    }
    Info c{};
    c.len = a.len + b.len;
    c.lIdx = a.lIdx, c.rIdx = b.rIdx;
    c.dp[0][0] = c.dp[0][1] = c.dp[1][0] = c.dp[1][1] = -infLL;
    for (int x = 0; x < 2; ++x) {
        for (int z = 0; z < 2; ++z) {
            c.dp[x][z] = max(c.dp[x][z], a.dp[x][0] + b.dp[0][z]);
            for (int y = 0; y < 2; ++y) {
                for (int u = 0; u < 2; ++u) {
                    if (y || u) {
                        c.dp[x][z] = max(c.dp[x][z], a.dp[x][y] + b.dp[u][z] + (y && u ? W[b.lIdx] : 0));
                    }
                }
            }
        }
    }
    return c;
}

Info t[N * 2];

void pull(int x) {
    t[x] = t[x << 1] + t[x << 1 | 1];
}

void leaf(int i) {
    t[i + sz].len = 1;
    t[i + sz].lIdx = t[i + sz].rIdx = i;
    t[i + sz].dp[0][0] = 0;
    t[i + sz].dp[1][1] = D[i] - W[i] - W[i + 1];
}

void init(int n) { // n - 1
    sz = 1 << __lg(n) + !!(n & (n - 1));
    for (int i = 0; i < 2 * sz; ++i) {
        t[i].nul();
    }
    for (int i = 0; i < n; ++i) {
        leaf(i);
    }
    for (int i = sz - 1; i > 0; --i) {
        pull(i);
    }
}

void upd(int i) {
    for (int x = i + sz; x /= 2; ) {
        pull(x);
    }
}

Info rangeSum(int l, int r, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return Info();
    }
    if (l <= lx && rx <= r) {
        return t[x];
    }
    int mid = lx + rx >> 1;
    return rangeSum(l, r, x << 1, lx, mid) + rangeSum(l, r, x << 1 | 1, mid, rx);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i) {
        cin >> W[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        cin >> D[i];
    }

    init(n - 1);

    while (q--) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int p, x;
            cin >> p >> x;
            --p;
            W[p] = x;
            if (p < n - 1) {
                leaf(p);
                upd(p);
            }
            if (p > 0) {
                leaf(p - 1);
                upd(p - 1);
            }
        } else if (tp == 2) {
            int p, x;
            cin >> p >> x;
            --p;
            D[p] = x;
            leaf(p);
            upd(p);
        } else {
            int l, r, add;
            cin >> l >> r >> add;
            l -= 1, r -= 1;
            Info dp = rangeSum(l, r);
            ll ans = 0;
            for (int x = 0; x < 2; ++x) {
                for (int y = 0; y < 2; ++y) {
                    ans = max(ans, dp.dp[x][y]);
                    ans = max(ans, dp.dp[x][y] + add - (1 - x) * W[l] - (1 - y) * W[r]);
                }
            }
            cout << ans << '\n';
        }
    }

    return 0;
}