#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1e6 + 10, MOD = 1e9 + 7;
int f[N], inv_f[N];

int mul(int a, int b) {
    return 1ll * a * b % MOD;
}

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

int cnk(int n, int k) {
    if (k < 0 || k > n) return 0;
    return mul(f[n], mul(inv_f[k], inv_f[n - k]));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    f[0] = inv_f[0] = 1;
    for (int i = 1; i < N; i++) {
        f[i] = mul(f[i - 1], i);
        inv_f[i] = inv(f[i]);
    }
    int n;
    cin >> n;
    int res = 1;
    for (int i = 2; i <= n; i++) {
        int val = 0;
        for (int k = 0; k <= i - 1; k++) {
            val = add(val, mul(cnk(i - 1, k), cnk(i - k - 1, k + 1)));
        }
        res = mul(res, val);
    }
    cout << res << endl;
    return 0;
}