#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define pb push_back
#define all(a) a.begin(), a.end()

struct point {
    int x, y;
    point() {
        x = y = 0;
    }
    point(int x_, int y_) {
        x = x_;
        y = y_;
    }
};

struct vec {
    int x, y;
    vec(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    vec(int x_, int y_) {
        x = x_;
        y = y_;
    }
    ll operator ^(vec v) {
        return 1ll * x * v.y - 1ll * y * v.x;
    }
};

const int N = 2e5 + 10;
point p[N];
vector<pair<int, int>> g[N];

int half(vec v1) {
    return (v1.y > 0 || v1.y == 0 && v1.x > 0 ? 1 : -1);
}

bool cmp(pair<vec, int> a, pair<vec, int> b) {
    vec v1 = a.first, v2 = b.first;
    int h1 = half(v1);
    int h2 = half(v2);
    if (h1 != h2) {
        return h1 < h2;
    } else {
        return (v1 ^ v2) > 0;
    }
}

set<int> mp[N];

int fa[N], sz[N];

int find(int x) {
    return x == fa[x] ? x : fa[x] = find(fa[x]);
}

bool unite(int x, int y) {
    x = find(x), y = find(y);
    if (x == y) {
        return false;
    }
    fa[y] = x;
    sz[x] += sz[y];
    return true;
}

int ANS;

void dfs(int v, int par = -1) {
    for (auto [u, ind] : g[v]) {
        if (u != par) {
            dfs(u, v);
        }
    }
    vector<pair<vec, int>> a;
    vector<int> inds;
    for (auto [u, ind] : g[v]) {
        vec v1(p[v], p[u]);
        vec rev1(-v1.x, -v1.y);
        a.pb({v1, u + 1});
        a.pb({rev1, -(u + 1)});
        mp[u + 1].clear();
        inds.pb(u + 1);
    }
    sort(all(a), cmp);
    for (int t = 0; t < 2; t++) {
        int last = -1;
        for (int _ = 0; _ < 2; _++) {
            for (int i = 0; i < a.size(); i++) {
                if (a[i].second > 0) {
                    last = a[i].second;
                } else if (last != -1) {
                    mp[abs(a[i].second)].insert(last);
                }
            }
        }
        reverse(all(a));
    }
    for (int i : inds) {
        fa[i] = i;
        sz[i] = 1;
    }
    for (auto [u, i] : g[v]) {
        vec v1(p[v], p[u]);
        int col = -1;
        for (int j : mp[u + 1]) {
            vec v2(p[j - 1], p[v]);
            if ((v1 ^ v2) == 0) {
                col = j;
            }
        }
        if (col != -1) {
            mp[u + 1].clear();
            mp[u + 1].insert(col);
        }
    }
    map<pair<int, int>, int> cnt;
    for (int u : inds) {
        for (int to : mp[u]) {
            cnt[minmax(u, to)]++;
        }
    }
    for (auto arr : cnt) {
        if (arr.second == 2) {
            auto [a, b] = arr.first;
            unite(a, b);
        }
    }
    for (int i : inds) {
        if (fa[i] == i) {
            ANS -= (sz[i] / 2);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    ANS = n - 1;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].pb({b, i + 1});
        g[b].pb({a, i + 1});
    }
    dfs(0);
    cout << ANS << endl;
    return 0;
}