#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first

const int mod = 1e9 + 7;

struct Modint {
    int x;
    Modint() {
        x = 0;
    }
    Modint (int _x) {
        while (_x >= mod) { _x -= mod; }
        while (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint (long long _x) {
        if (_x >= mod || _x <= -mod) { _x %= mod; }
        if (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint operator+(const Modint& other) const {
        return Modint(x + other.x);
    }
    Modint operator-(const Modint& other) const {
        return Modint(x - other.x);
    }
    Modint operator*(const Modint& other) const {
        return Modint(x * 1ll * other.x);
    }
    void operator+=(const Modint& other) {
        *this = *this + other;
    }
    void operator*=(const Modint& other) {
        *this = *this * other;
    }
    Modint operator^(int k) {
        Modint res = 1, tmp = x;
        while (k > 0) {
            if (k & 1) {
                res *= tmp;
            }
            tmp *= tmp;
            k >>= 1;
        }
        return res;
    }
    ~Modint() {}
};

vector<Modint> fact, invFact;

void buildFact(int n) {
    fact.resize(n + 1);
    invFact.resize(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    invFact[n] = fact[n] ^ (mod - 2);
    for (int i = n; i > 0; --i) {
        invFact[i - 1] = invFact[i] * i;
    }
}

Modint C(int n, int k) {
    if (n < 0 || k < 0 || n < k) { return 0; }
    return fact[n] * invFact[k] * invFact[n - k];
}

Modint split(int n, int k) {
    // n with k numbers
    if (n < 0 || k < 0) { return 0; }
    if (n == 0) {
        return (k == 0);
    }
    if (k == 0) {
        return 0;
    }
    return C(n - k + 1, k - 1);
}

void solve() {
    int n;
    cin >> n;
    Modint ans = 0;
    for (int mex = 1, rest = n; mex <= n + 1 && rest >= 0; ++mex) {
        for (int k = 0; k <= n; ++k) {
            // cerr << "mex: " << mex << ", rest: " << rest << ", k: " << k << '\n';
            Modint w1 = split(rest, k);
            Modint w2 = split(rest - mex, k - 1);
            cerr << w1.x << ' ' << w2.x << '\n';
            ans += (w1 - w2) * mex;
        }
        rest -= mex;
    }
    cout << ans.x << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    buildFact(3000);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
