#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

// ARGHHHHHHHHHHHHHHHH
//#define int long long
// ARGHHHHHHHHHHHHHHHH

string s;

bool check(int l, int r) {
	if (r - l <= 0) return true;

	if (r - l == 1) {
		return s[l] == 'a';
	}

	if (r - l == 2) {
		return s[l] != 'b' || s[l + 1] != 'b';
	}

	if (r - l == 3) {
		if (s[l] == 'a' && check(l + 1, r)) return true;
		if (s[l + 2] == 'a' && check(l, r - 1)) return true;
		return false;
	}

	return false;
}

struct node {
	int l = -1, r = -1;
	bool can[2][2] = {};
};

int n;
const int MAXN = 1 << 18;
node t[2 * MAXN];

node merge(node a, node b) {
	if (a.l == -1) return b;
	if (b.l == -1) return a;

	node c;
	c.l = a.l;
	c.r = b.r;

	for (int i = 0; i < 2; i++) {
		for (int j = 0; j < 2; j++) {
			for (int k = 0; k < 2; k++) {
				for (int w = 0; w < 2; w++) {
					c.can[i][w] |= a.can[i][j] && b.can[k][w] && check((j == 1 ? a.r : a.r - 1), (k == 0 ? b.l : b.l + 1));
				}
			}
		}
	}
	return c;
}

void update(int i, int x, int l, int r) {
	if (l + 1 == r) {
		t[x].l = l;
		t[x].r = r;
		if (s[l] == 'a') {
			t[x].can[0][1] = 1;
		} else {
			t[x].can[0][1] = 0;
		}
		t[x].can[1][1] = t[x].can[0][0] = 1;
		return;
	}

	int m = (l + r) / 2;
	if (i < m) {
		update(i, 2 * x + 1, l, m);
	} else {
		update(i, 2 * x + 2, m, r);
	}
	t[x] = merge(t[2 * x + 1], t[2 * x + 2]);
}

void update(int i) {
	update(i, 0, 0, n);
}

node get(int lq, int rq, int x, int l, int r) {
	if (rq <= l || r <= lq) return node();
	if (lq <= l && r <= rq) return t[x];

	int m = (l + r) / 2;
	node a = get(lq, rq, 2 * x + 1, l, m);
	node b = get(lq, rq, 2 * x + 2, m, r);
	return merge(a, b);
}

bool get(int lq, int rq) {
	return get(lq, rq, 0, 0, n).can[0][1];
}

int32_t main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	cin >> n >> s;
	for (int i = 0; i < n; i++) update(i);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t;
		cin >> t;

		if (t == 1) {
			int id;
			cin >> id;
			id--;
			s[id] = (s[id] == 'a' ? 'b' : 'a');
			update(id);
		} else {
			int l, r;
			cin >> l >> r;
			l--;
			cout << (get(l, r) ? "YES\n" : "NO\n");
		}
	}


	return 0;
}