#pragma GCC optimize("Ofast")
#pragma target("sse,sse2,sse3,sse4,avx2")
#include <bits/stdc++.h>

using namespace std;

vector <int> d(2e5), w(2e5);
vector < array<long long, 5> > tree(6e5, array<long long, 5>());

array<long long, 5> merge(array<long long, 5> a, array<long long, 5> b, int len) {
    a[4] += b[4];
    if (len >= b[0] + a[1]) {
        a[4] += len - b[0] - a[1];
        a[0] = a[2], a[1] = b[3];
        a[3] = b[3];
        return a;
    }
    if (a[1] + b[2] <= len) {
        b[1] -= (len - a[1] - b[2]);
    } else {
        a[2] = min(a[0], a[2] + b[2] + a[1] - len);
    }
    if (b[0] + a[3] <= len) {
        a[0] -= (len - b[0] - a[3]);
    } else {
        b[3] = min(b[1], b[3] + b[0] + a[3] - len);
    }
    a[1] = b[1], a[3] = b[3];
    return a;
}

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v][0] = w[l];
        tree[v][1] = w[l];
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2], d[m - 1]);
}

void upd_road(int v, int l, int r, int &l0) {
    if (l > l0 || r - 1 <= l0) return;
    if (r - l == 1) return;
    int m = (r + l) / 2;
    upd_road(2 * v + 1, l, m, l0);
    upd_road(2 * v + 2, m, r, l0);
    tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2], d[m - 1]);
}

void upd_ice(int v, int l, int r, int &l0) {
    if (l > l0 || r <= l0) return;
    if (r - l == 1) {
        tree[v][0] = w[l];
        tree[v][1] = w[l];
        return;
    }
    int m = (r + l) / 2;
    upd_ice(2 * v + 1, l, m, l0);
    upd_ice(2 * v + 2, m, r, l0);
    tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2], d[m - 1]);
}


array<long long, 5> get(int v, int l, int r, int &l0, int &r0) {
    if (l0 <= l && r <= r0) return tree[v];
    int m = (r + l) / 2;
    if (m >= r0) return get(2 * v + 1, l, m, l0, r0);
    if (m <= l0) return get(2 * v + 2, m, r, l0, r0);
    return merge(get(2 * v + 1, l, m, l0, r0), get(2 * v + 2, m, r, l0, r0), d[m - 1]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, t, l, r, x;
    cin >> n >> q;
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < n - 1; i++) cin >> d[i];
    build(0, 0, n);
//    for (int i = 0; i < 16; i++) {
//        cout << tree[i][0] << ' ' << tree[i][1] << ' ' << tree[i][2] << ' ' << tree[i][3] << ' ' << tree[i][4] << endl;
//    }
    while (q--) {
        cin >> t >> l;
        l--;
        if (t == 1) {
            cin >> x;
            w[l] = x;
            upd_ice(0, 0, n, l);
        } else if (t == 2) {
            cin >> x;
            d[l] = x;
            upd_road(0, 0, n, l);
        } else {
            cin >> r >> x;
            array<long long, 5> ans = get(0, 0, n, l, r);
            cout << ans[4] + max(0ll, x - ans[0] - ans[3]) << endl;
        }
    }
}

//6 7
//5 9 5 1 9 5
//4 8 10 4 5
//3 1 6 12
//3 4 6 5
//2 4 1
//1 6 3
//3 4 6 5
//1 2 3
//3 2 3 6