//#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

const ll MOD = 1'000'000'007;

constexpr int R = 1 << 17, MAXN = 2e5 + 10;

struct Vector {
    int x, y;
    Vector(int x_ = 0, int y_ = 0) {
        x = x_;
        y = y_;
    }
    friend Vector operator-(Vector a, Vector b) {
        return Vector(a.x - b.x, a.y - b.y);
    }
    friend int operator^(Vector a, Vector b) {
        return a.x * b.y - a.y * b.x;
    }
};

vector<int> g[MAXN];


bool comp(Vector aa, Vector bb) {
    if (aa.y >= 0 && bb.y < 0)
        return true;
    if (aa.y < 0 && bb.y >= 0)
        return false;
    if (aa.y == 0 && bb.y == 0)
        return (aa.x < 0 && bb.x > 0);
    return (aa ^ bb) < 0;
}

int dfs(int v, vector<vector<int>> &gg, vector<int> &used) {
    used[v] = 1;
    int sz = 1;
    for (auto u : gg[v]) {
        if (!used[u]) {
            sz += dfs(u, gg, used);
        }
    }
    return sz;
}

void solve() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &i : a)
        cin >> i.x >> i.y;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end(), [&](int j, int k) {
            Vector aa = a[j] - a[i], bb = a[k] - a[i];
            return comp(aa, bb);
        });
    }
    set<pair<pair<int, int>, pair<int, int>>> e;
    for (int u = 0; u < n; ++u) {
        for (auto v: g[u]) {
            Vector c = a[v] - a[u];
            int l = -1, r = g[v].size();
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (comp(a[g[v][m]] - a[v], c))
                    l = m;
                else
                    r = m;
            }
            r %= g[v].size();
            if (((a[g[v][r]] - a[v]) ^ c) == 0)
                e.insert({{u, v},
                          {v, g[v][r]}});
            else {
                l = (l + g[v].size()) % g[v].size();
                e.insert({{u, v},
                          {v, g[v][l]}});
                e.insert({{u, v},
                          {v, g[v][r]}});
            }
        }
    }
    for (int u = 0; u < n; ++u) {
        for (auto v : g[u]) {
            if (e.count(make_pair(make_pair(u, v), make_pair(v, u)))) {
                e.erase(make_pair(make_pair(u, v), make_pair(v, u)));
            }
        }
    }
//    for (auto vl : e) {
//        cout << vl.first.first << ' ' << vl.first.second << ' ' << vl.second.first << ' ' << vl.second.second << '\n';
//    }
    vector<pair<int, int>> vs;
    for (int v = 0; v < n; ++v) {
        for (auto u : g[v]) {
            vs.emplace_back(v, u);
        }
    }
    sort(vs.begin(), vs.end());
    vector<vector<int>> gg(vs.size());
    for (int v = 0; v < n; ++v) {
        for (auto u : g[v]) {
            auto it = e.lower_bound(make_pair(make_pair(u, v), make_pair(0, 0)));
            while (true) {
                if (it != e.end() && it->first == make_pair(u, v)) {
                    int w = it->second.second;
                    if (e.count(make_pair(make_pair(w, v), make_pair(v, u)))) {
                        int ind1 = lower_bound(vs.begin(), vs.end(), make_pair(v, u)) - vs.begin();
                        int ind2 = lower_bound(vs.begin(), vs.end(), make_pair(v, w)) - vs.begin();
                        gg[ind1].push_back(ind2);
                        gg[ind2].push_back(ind1);
                    }
                    it++;
                } else {
                    break;
                }
            }
        }
    }
    for (int i = 0; i < (int)vs.size(); ++i) {
        sort(gg[i].begin(), gg[i].end());
        gg[i].resize(unique(gg[i].begin(), gg[i].end()) - gg[i].begin());
    }
    int ans = n - 1;
    vector<int> used(vs.size());
    for (int i = 0; i < (int)vs.size(); ++i) {
        if (!used[i]) {
            ans -= dfs(i, gg, used) / 2;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
