#include <bits/stdc++.h>

#define int long long
#define sz(x) (int)x.size()

using namespace std;

struct Fenwick {
    int n;
    vector<int> t;

    void init(int n) {
        this->n = n;
        t.resize(n);
    }

    int get(int idx) {
        int res = 0;
        for (; idx >= 0; idx = (idx & (idx + 1)) - 1) res += t[idx];
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }

    void add(int idx, int val) {
        while (idx < n) {
            t[idx] += val;
            idx |= idx + 1;
        }
    }
};

int32_t main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    Fenwick f;
    f.init(n);
    for (int i = 0; i < n; i++) {
        if (s[i] == 'a') {
            f.add(i, +1);
        }
    }
    set<int> setik;
    for (int i = 0; i < n - 2; i++) {
        if (s[i] == 'b' && s[i + 1] == 'b' && s[i + 2] == 'b') {
            setik.insert(i);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int i;
            cin >> i;
            i--;
            for (int j = max(0LL, i - 2); j <= i && j + 2 < n; j++) {
                if (s[j] == 'b' && s[j + 1] == 'b' && s[j + 2] == 'b') {
                    setik.erase(j);
                }
            }
            if (s[i] == 'a') {
                f.add(i, -1);
                s[i] = 'b';
            } else {
                f.add(i, +1);
                s[i] = 'a';
            }
            for (int j = max(0LL, i - 2); j <= i && j + 2 < n; j++) {
                if (s[j] == 'b' && s[j + 1] == 'b' && s[j + 2] == 'b') {
                    setik.insert(j);
                }
            }
        } else {
            int l, r;
            cin >> l >> r;
            l--; r--;
            int len = r - l + 1;
            int as = f.get(l, r);
            int bs = len - as;
            if (bs > as) {
                cout << "NO\n";
                continue;
            }
            if (len == 1) {
                if (s[l] == 'a') {
                    cout << "YES";
                } else {
                    cout << "NO";
                }
                cout << '\n';
                continue;
            }
            if (s[l] == 'b' && s[l + 1] == 'b') {
                cout << "NO\n";
                continue;
            }
            if (s[r - 1] == 'b' && s[r] == 'b') {
                cout << "NO\n";
                continue;
            }
            auto it = setik.lower_bound(l);
            if (it != setik.end() && *it <= r - 2) {
                cout << "NO\n";
                continue;
            }
            cout << "YES\n";
        }
    }
    return 0;
}
