#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
};

struct Node {
    int ansl = 0;
    int ansr = 0;
    int ans = 0;
    int len = 0;
};

Node merge(Node a, Node b) {
    int ans = max(a.ans, b.ans);
    int ansl = a.ansl;
    int ansr = a.ansr;
    int len = a.len + b.len;
    Node res;
    res.len = len;
    if (a.ansr == a.len) {
        if (b.ansl == b.len) {
            ansl = ansr = a.len + b.len;
        } else {
            ansl = a.ansl + b.ansl;
        }
        mxr(ans, a.len + b.ansl);
    } else if (b.ansl == b.len) {
        ansr = a.ansr + b.ansr;
        mxr(ans, b.len + a.ansr);
    } else {
        mxr(ans, b.ansl + a.ansr);
    }
    res.ans = ans;
    res.ansl = ansl;
    res.ansr = ansr;
    return res;
}

struct Seg {
private:
    vector <Node> d;
    int n;

    void upd(int i) {
        d[i] = merge(d[2 * i], d[2 * i + 1]);
    }

    Node get(int ql, int qr, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return Node{};
        }
        if (l >= ql && r <= qr) {
            return d[i];
        }
        int m = (l + r) / 2;
        return merge(get(ql, qr, l, m, 2 * i),
                     get(ql, qr, m, r, 2 * i + 1));
    }

public:
    explicit Seg(const string& s) {
        n = 1;
        while (n < sz(s)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(s); ++i) {
            d[i].len = 1;
            if (s[i] == 'b') {
                d[i].ansl = d[i].ansr = d[i].ans = 1;
            }
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        return get(l, r, 0, n, 1).ans;
    }

    void upd(int i, char c) {
        i += n;
        int t = 0;
        if (c == 'b') {
            t = 1;
        }
        d[i].ansl = d[i].ansr = d[i].ansl = 1;
        while (i >>= 1) {
            upd(i);
        }
    }
};

struct Sparse {
private:
    vector <vector <int> > d;
    int n;
    vector <int> lg;

public:
    explicit Sparse(const vector <int>& v) {
        n = sz(v);
        lg.resize(n + 1);
        for (int i = 2; i <= n; ++i) {
            lg[i] = lg[i / 2] + 1;
        }
        d.resize(lg[n] + 1, vector <int> (n));
        d[0] = v;
        for (int k = 1; k <= lg[n]; ++k) {
            for (int i = 0; i + (1 << k) <= n; ++i) {
                d[k][i] = max(d[k - 1][i], d[k - 1][i + (1 << (k - 1))]);
            }
        }
    }

    int get(int l, int r) {
        int q = lg[r - l + 1];
        return max(d[q][l], d[q][r - (1 << q) + 1]);
    }
};

const int MAXN = 2e5 + 1;
vector <int> g[MAXN];
int depth[MAXN];
vector <int> bd[MAXN];
vector <int> bin[MAXN];
vector <int> bout[MAXN];
int dp[MAXN];
int tin[MAXN], tout[MAXN];

int TIME = 0;

void calcd(int cur) {

    bd[depth[cur]].push_back(cur);
    bin[depth[cur]].push_back(tin[cur]);
    bout[depth[cur]].push_back(tout[cur]);
    for (auto to : g[cur]) {
        depth[to] = depth[cur] + 1;
        calcd(to);
    }
}

int pw(int a, int n) {
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        __int128_t b = (__int128_t)ans * a;
        b = min(b, (__int128_t)2e18);
        ans = b;
    }
    return ans;
}
signed main() {
#ifdef BUY
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif


    int n; cin >> n;
    int l = 0, r = 1e14 + 1;
    while (l + 1 != r) {
        int m = (l + r) / 2;
        cout << "? " << m << endl;
        int a; cin >> a;
        if (a == n) l = m;
        else r = m;
    }

    int l1 = 0, r1 = 1e14 + 1;
    while (l1 + 1 != r1) {
        int m = (l1 + r1) / 2;
        cout << "? " << m << endl;
        int a; cin >> a;
        if (a <= n + 1) l1 = m;
        else r1 = m;
    }

    int l0 = 2, r0 = 2024;
    while (l0 + 1 != r0) {
        int m = (l0 + r0) / 2;

        if ((__int128_t)pw(m, n + 1) * (m - 1) <= r1 - r) l0 = m;
        else r0 = m;
    }

    int b = l0;

    int x = pw(b, n) - r;

    cout << "! " << x << ' ' << b << endl;
}