#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
};

struct Node {
    int ansl = 0;
    int ansr = 0;
    int ans = 0;
    int len = 0;
};

Node merge(Node a, Node b) {
    int ans = max(a.ans, b.ans);
    int ansl = a.ansl;
    int ansr = a.ansr;
    int len = a.len + b.len;
    Node res;
    res.len = len;
    if (a.ansr == a.len) {
        if (b.ansl == b.len) {
            ansl = ansr = a.len + b.len;
        } else {
            ansl = a.ansl + b.ansl;
        }
        mxr(ans, a.len + b.ansl);
    } else if (b.ansl == b.len) {
        ansr = a.ansr + b.ansr;
        mxr(ans, b.len + a.ansr);
    } else {
        mxr(ans, b.ansl + a.ansr);
    }
    res.ans = ans;
    res.ansl = ansl;
    res.ansr = ansr;
    return res;
}

struct Seg {
private:
    vector <Node> d;
    int n;

    void upd(int i) {
        d[i] = merge(d[2 * i], d[2 * i + 1]);
    }

    Node get(int ql, int qr, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return Node{};
        }
        if (l >= ql && r <= qr) {
            return d[i];
        }
        int m = (l + r) / 2;
        return merge(get(ql, qr, l, m, 2 * i),
                     get(ql, qr, m, r, 2 * i + 1));
    }

public:
    explicit Seg(const string& s) {
        n = 1;
        while (n < sz(s)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(s); ++i) {
            d[i].len = 1;
            if (s[i] == 'b') {
                d[i].ansl = d[i].ansr = d[i].ans = 1;
            }
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        return get(l, r, 0, n, 1).ans;
    }

    void upd(int i, char c) {
        i += n;
        int t = 0;
        if (c == 'b') {
            t = 1;
        }
        d[i].ansl = d[i].ansr = d[i].ansl = 1;
        while (i >>= 1) {
            upd(i);
        }
    }
};

const int MAXN = 1e5 + 1;
int fact[MAXN];

const int MOD = 1e9 + 7;

int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) {
            res = res * a % MOD;
        }
        a = a * a % MOD;
        b >>= 1;
    }
    return res;
}

int f(int a) {
    return binpow(a, MOD - 2);
}

int C(int n, int k) {
    return fact[n] * f(fact[k] * fact[n - k] % MOD) % MOD;
}

signed main() {
#ifdef BUY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    vector <int> v(n);
    vector <int> cnt(3);
    for (auto &i : v) {
        cin >> i;
        ++cnt[i % 3];
    }
    int res = 0;
    if (cnt[1] == cnt[2] + 1 || cnt[2] == cnt[1] + 1 || cnt[1] == cnt[2] + 2 || cnt[2] == cnt[1] + 2) {
        res += 1;
    }
    cerr << res << '\n';
    res = res * C(n - 1, cnt[0]) % MOD;
    res = res * fact[cnt[1]] % MOD;
    res = res * fact[cnt[2]] % MOD;

    cout << res;
}