//#include <bits/stdc++.h>
//
//using namespace std;
//using ll = long long;
//
//struct node {
//    bool a00, a10, a01, a11;
//    ll tl, tr;
//};
//
//struct segtree {
//    ll n;
//    vector<node> t;
//    string s;
//
//    segtree() {}
//
//    segtree(string& ss) {
//        n = ss.size();
//        s = ss;
//        t.resize(4 * n);
//        build(0, 0, n- 1, s);
//    }
//
//    node merge(node a, node b) {
//        bool a00 = ((a.a00 && b.a00) || (a.a01 && b.a10 && s[a.tr] == 'a' && s[b.tl] == 'b'));
//        bool a01 = ((a.a00 && b.a01) || (a.a01 && b.a11 && s[a.tr] == 'a' && s[b.tl] == 'b'));
//        bool a10 = ((a.a10 && b.a00) || (a.a10 && b.a10 && s[a.tr] == 'a' && s[b.tl] == 'b'));
//    }
//
//    void build(ll v, ll tl, ll tr, string& ss) {
//        if (tl == tr) {
//            t[v].a00 = true;
//            t[v].a10 = false;
//            t[v].a01 = false;
//            t[v].a11 = true;
//            return;
//        }
//        ll tm = (tl + tr) / 2;
//        build(2 * v + 1, tl, tm, ss);
//        build(2 * v + 2, tm + 1, tr, ss);
//        t[v] = merge(t[2 * v + 1], t[2 * v + 2]);
//    }
//
//};
//
//int main() {
//
//
//    return 0;
//}


#include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool check(vector<vector<int>> &v) {
    map<int, int> mp;
    int n = v.size();
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += v[i][j];
        }
        mp[sum]++;
    }
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += v[j][i];
        }
        mp[sum]++;
    }
    if (mp.size() == 1) {
        return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    if (n <= 8) {
        for (int x1 = 0; x1 < n; x1++) {
            for (int y1 = 0; y1 < n; y1++) {
                for (int x2 = 0; x2 < n; x2++) {
                    for (int y2 = 0; y2 < n; y2++) {
                        vector<vector<int>> v = a;
                        int tmp = v[x1][y1];
                        v[x1][y1] = v[x2][y2];
                        v[x2][y2] = tmp;
                        if (check(v)) {
                            cout << x1 + 1 << " " << y1 + 1 << "\n";
                            cout << x2 + 1 << " " << y2 + 1;
                            return 0;
                        }
                    }
                }
            }
        }
    }

    map<int, int> hui;
    vector<int> rows(n);
    vector<int> cols(n);
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[i][j];
        }
        rows[i] = sum;
        hui[sum]++;
    }

    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[j][i];
        }
        cols[i] = sum;
        hui[sum]++;
    }

    int maxx_summ = 0;
    int maxx_cnt = 0;
    for (auto [sum, cnt]: hui) {
        if (cnt > maxx_cnt) {
            maxx_summ = sum;
            maxx_cnt = cnt;
        }
    }

    int first_i = -1;
    int second_i = -1;
    int first_j = -1;
    int second_j = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[i][j];
        }

        if (first_i == -1 and sum != maxx_summ) {
            first_i = i;
        } else if (sum != maxx_summ) {
            second_i = i;
        }
    }

    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) {
            sum += a[j][i];
        }

        if (first_j == -1 and sum != maxx_summ) {
            first_j = i;
        } else if (sum != maxx_summ) {
            second_j = i;
        }
    }

    if (second_i == -1) {
        cout << first_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
        return 0;
    }
    if (second_j == -1) {
        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << first_j + 1;
        return 0;
    }

    if (rows[first_i] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ &&
        cols[first_j] - a[first_i][first_j] + a[second_i][second_j] == maxx_summ) {
        cout << first_i + 1 << " " << first_j + 1 << "\n" << second_i + 1 << " " << second_j + 1;
        return 0;
    } else {
        cout << second_i + 1 << " " << first_j + 1 << "\n" << first_i + 1 << " " << second_j + 1;
    }

    return 0;
}