#include <bits/stdc++.h>

using namespace std;

vector<vector<long long>> mtx;
vector<long long> rowsum, colsum;

void swp(int x1, int y1, int x2, int y2) {
    rowsum[y1] -= mtx[y1][x1];
    rowsum[y2] -= mtx[y2][x2];
    colsum[x1] -= mtx[y1][x1];
    colsum[x2] -= mtx[y2][x2];
    swap(mtx[y1][x1], mtx[y2][x2]);
    rowsum[y1] += mtx[y1][x1];
    rowsum[y2] += mtx[y2][x2];
    colsum[x1] += mtx[y1][x1];
    colsum[x2] += mtx[y2][x2];
}

int main() {
    long long n;
    cin >> n;
    long long rsum = 0;
    for(long long i = 1; i <= n * n; i++) rsum += i;
    rsum /= n;
    mtx.resize(n, vector<long long>(n));
    rowsum.resize(n);
    colsum.resize(n);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            cin >> mtx[i][j];
            rowsum[i] += mtx[i][j];
            colsum[j] += mtx[i][j];
        }
    }
    vector<int> nrRow, nrCol;
    for(int i = 0; i < n; i++) {
        if(rowsum[i] != rsum) nrRow.push_back(i);
    }
    for(int i = 0; i < n; i++) {
        if(colsum[i] != rsum) nrCol.push_back(i);
    }
    if(nrRow.size() == 2 && nrCol.size() == 2) {
        swp(nrCol[0], nrRow[0], nrCol[1], nrRow[1]);
        if(rowsum[nrRow[0]] == rsum &&
           rowsum[nrRow[1]] == rsum &&
           colsum[nrCol[0]] == rsum &&
           colsum[nrCol[1]] == rsum) {
            cout << nrRow[0] + 1 << ' ' << nrCol[0] + 1 << '\n';
            cout << nrRow[1] + 1 << ' ' << nrCol[1] + 1 << '\n';
            return 0;
        }
        swp(nrCol[0], nrRow[0], nrCol[1], nrRow[1]);
        swp(nrCol[0], nrRow[1], nrCol[1], nrRow[0]);
        if(rowsum[nrRow[0]] == rsum &&
           rowsum[nrRow[1]] == rsum &&
           colsum[nrCol[0]] == rsum &&
           colsum[nrCol[1]] == rsum) {
            cout << nrRow[0] + 1 << ' ' << nrCol[1] + 1 << '\n';
            cout << nrRow[1] + 1 << ' ' << nrCol[0] + 1 << '\n';
            return 0;
        }
    }
    if(nrRow.size() == 2 && nrCol.size() == 0) {
        for(int i = 0; i < n; i++) {
            swp(i, nrRow[0], i, nrRow[1]);
            if(rowsum[nrRow[0]] == rsum &&
               rowsum[nrRow[1]] == rsum &&
               colsum[i] == rsum &&
               colsum[i] == rsum) {
                cout << nrRow[0] + 1 << ' ' << i + 1 << '\n';
                cout << nrRow[1] + 1 << ' ' << i + 1 << '\n';
                return 0;
            }
            swp(i, nrRow[0], i, nrRow[1]);
        }
    }
    if(nrRow.size() == 0 && nrCol.size() == 2) {
        for(int i = 0; i < n; i++) {
            swp(nrCol[0], i, nrCol[1], i);
            if(rowsum[i] == rsum &&
               rowsum[i] == rsum &&
               colsum[nrCol[0]] == rsum &&
               colsum[nrCol[1]] == rsum) {
                cout << i + 1 << ' ' << nrCol[0] + 1 << '\n';
                cout << i + 1 << ' ' << nrCol[1] + 1 << '\n';
                return 0;
            }
            swp(nrCol[0], i, nrCol[1], i);
        }
    }
    return -1;
}
